// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 julio 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ATDT AntenaTelevisorDosTornillos
// El archivo dibuja una antena algo pasada de moda para radio-television, 
// para utilizar como auxiliar en el interior de las habitaciones cuando no se
// dispone de un sistema de mayor eficacia. Es compatible con POV-Ray 3.1.
//
// La macro principal no tiene parametros.   
// #macro ATDT_DefaultAntena( )
//
// Para poder mover los elementos, puede utilizar la siguiente macro.
// #macro ATDT_Antena( AnguloSintonizar, GiroTorre, AnguloElevacion,
//                        ExtensionDerecha, RotarDerecha,
//                        ExtensionIzquierda, RotarIzquierda )
//      AnguloSintonizar        : Angulo de rotacion de la perilla.
//              Valor por defecto 90.
//      GiroTorre               : Angulo de la torre de rotacion de la antena
//              esferica. Valor por defecto 10.
//      AnguloElevacion         : Angulo de elevacion de la antena esferica.
//              Valor por defecto 45.
//      ExtensionDerecha        : Grado de extension de la antena alargable derecha, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 1.00.
//      RotarDerecha            : Vector de rotacion para la antena alargable derecha,
//              valor nulo apunta hacia el cenit. Valor por defecto <  0, 10, 30>.
//      ExtensionIzquierda      : Grado de extension de la antena alargable izquierda, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 0.75.
//      RotarIzquierda          : Vector de rotacion para la antena alargable izquierda,
//              valor nulo apunta hacia el cenit. Valor por defecto < 10,  0,-20>.
//
// La siguiente macro permite modificar algunas caracteristicas.
// #macro ATDT_AntenaTelevisorDosTornillos( AnguloSintonizar, GiroTorre,
//                AnguloElevacion, ExtensionDerecha, RotarDerecha,
//                ExtensionIzquierda, RotarIzquierda, FrenteFundamental,
//                PrimerNivel, BordePrimerNivel, SegundoNivel,
//                TercerNivel, GruesoTercerNivel,
//                RadioEsferico, MaterialPrincipal, MaterialMarca,
//                MaterialEsferico, MaterialAntena )
//      AnguloSintonizar        : Angulo de rotacion de la perilla.
//              Valor por defecto 90.
//      GiroTorre               : Angulo de la torre de rotacion de la antena
//              esferica. Valor por defecto 10.
//      AnguloElevacion         : Angulo de elevacion de la antena esferica.
//              Valor por defecto 45.
//      ExtensionDerecha        : Grado de extension de la antena alargable derecha, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 1.00.
//      RotarDerecha            : Vector de rotacion para la antena alargable derecha,
//              valor nulo apunta hacia el cenit. Valor por defecto <  0, 10, 30>.
//      ExtensionIzquierda      : Grado de extension de la antena alargable izquierda, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 0.75.
//      RotarIzquierda          : Vector de rotacion para la antena alargable izquierda,
//              valor nulo apunta hacia el cenit. Valor por defecto < 10,  0,-20>.  
//      FrenteFundamental       : Referencia para el frente de la antena.
//              Valor por defecto 91*L.        
//      PrimerNivel             : Alto de la primera base de la antena.
//              Valor por defecto 6*L.
//      BordePrimerNivel        : Borde en exceso de la primera base de la antena 
//              y grueso de la antena. Valor por defecto 3*L.
//      SegundoNivel            : Alto de la segunda base para la torre de la antena.
//              Valor por defecto 24*L.
//      TercerNivel             : Alto de referencia para la torre inferior.
//              Valor por defecto 32*L.
//      GruesoTercerNivel       : Valor de referencia para el grosor de la base
//              de la torre superior. Valor por defecto 23*L.
//      RadioEsferico           : Valor de referencia para las caracteristicas 
//              de la antena esferica. Valor por defecto 400*L.
//      MaterialPrincipal       : Material principal para el objeto.
//              Valor por defecto ATDT_MaterialPrincipal.
//      MaterialMarca           : Material para la decoracion cercana a la perilla.
//              Valor por defecto ATDT_MaterialMarca.
//      MaterialEsferico           : Material adicional para la antena esferica.
//              Valor por defecto ATDT_MaterialEsferico.
//      MaterialAntena          : Material para la antena. 
//              Valor por defecto ATDT_MaterialAntena.
//      
// La antena sin las antenas alargables tiene las siguientes caracteristicas:
//      Alto            = 125*L.
//      Frente X        = 110*L.
//      Profundidad Z   = 100*L.
// Con las antenas el tamano crece notablemente. El frente mira hacia Z-, gravedad Y-.
// El objeto se encuentra casi centrado sobre el plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ATDT_DefaultMaterialPrincipal        
//      Material principal para el objeto.
// #declare ATDT_DefaultMaterialMarca          
//      Material para la decoracion cercana a la perilla.
// #declare ATDT_DefaultMaterialEsferico         
//      Material adicional para la antena esferica.
// #declare ATDT_DefaultMaterialAntena        
//      Material para la antena.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ATDT_MaterialPrincipal                  = material { ... }        
//      Material principal para el objeto.
// #declare ATDT_MaterialMarca                      = material { ... }
//      Material para la decoracin cercana a la perilla.
// #declare ATDT_MaterialEsferico                   = material { ... }         
//      Material adicional para la antena esferica.
// #declare ATDT_MaterialAntena                     = material { ... }
//      Material para la antena.   
// #declare ATDT_ColorGrado                         = White;
//      Color a aplicar a las marcas del cilindro sintonizador.
//        
// Para colocarlo simplemente
// #include "ATDT.inc" 
// object { ATDT_DefaultAntena( ) }
//                                 
// Ejemplo con la macro de posicion
// #include "ATDT.inc"
// object { ATDT_Antena( 90, 10, 45, 1.00, <0,10,30>,0.75,<10,0,-20> ) }
// 
// Ejemplo con la macro detallada, mismo objeto default
// #include "ATDT.inc"   
// object                       {
//   ATDT_AntenaTelevisorDosTornillos( 90, 10, 45, 1.00, <0,10,30>,0.75,<10,0,-20>, 
//                      0.091, 0.006, 0.003, 0.024, 0.032, 0.023, 0.400,
//                      ATDT_MaterialPrincipal, ATDT_MaterialMarca,
//                      ATDT_MaterialEsferico, ATDT_MaterialAntena ) }
//        
// Con modificadores
// #include "ATDT.inc"
// #include "textures.inc"
// #declare ATDT_MaterialPrincipal   = material { textures { PinkAlabaster } }
// object        { ATDT_Antena( ) }
//
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "ATDT.inc" 

#declare FactorAcercamiento             = 6;

object                                  {
  ATDT_DefaultAntena( )   
  translate             -0.10*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
