// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 enero 2017
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//      
// R2X1 RelojDosPorUno
// El archivo dibuja un reloj de pulsera, el modelo real utilizado
// se vende con dos pulseras a escoger. 
// Es muy poco flexible pero incluye una macro para modificar
// texturas y unas pocas caracteristicas. Es compatible con POV-Ray 3.1.
//
// La macro principal tiene cinco parametros.   
// #macro R2X1_Reloj( AnguloHorario, AnguloMinutero, AnguloSegundero,
//                BanderaPulsera, BanderaPerilla )
//      AnguloHorario           : Angulo en grados para rotar el horario.
//      AnguloMinutero          : Angulo en grados para rotar el minutero.
//      AnguloSegundero         : Angulo en grados para rotar el segundero. 
//      BanderaPulsera          : "on" dibuja el soporte para pulsera, "off"
//            no lo dibuja.
//      BanderaPerilla          : "on" dibuja la perilla de calibracion,
//            "off" no la dibuja.
//
// La siguiente macro permite mayor control de las caracteristicas.
// #macro R2X1_Reloj2X1( AnguloHorario, AnguloMinutero, AnguloSegundero,
//                BanderaPulsera, BanderaPerilla, DiametroReloj,
//                DiametroCristal, GruesoReloj, ProfundidadCaratula,
//                AnchoBanda, SeparacionBanda, GruesoMetal, AnchoPerilla,
//                MaterialPrincipal, MaterialCristal, MaterialMetal,
//                MaterialPerilla, MaterialFosforescente, MaterialSegundero )
//      AnguloHorario           : Angulo en grados para rotar el horario.
//      AnguloMinutero          : Angulo en grados para rotar el minutero.
//      AnguloSegundero         : Angulo en grados para rotar el segundero.
//      BanderaPulsera          : "on" dibuja el soporte para pulsera, "off"
//            no lo dibuja.
//      BanderaPerilla          : "on" dibuja la perilla de calibracion,
//            "off" no la dibuja. 
//      DiametroReloj           : Diametro fundamental del reloj.
//            Valor por defecto 27.2*L.
//      DiametroCristal         : Diametro del vidrio protector del reloj. 
//            Valor por defecto 23.6*L.
//      GruesoReloj             : Grueso fundamental de reloj.  
//            Valor por defecto 6.4*L.
//      ProfundidadCaratula     : Espacio desde el vidrio a la caratula impresa.
//            Valor por defecto 1.0*L.
//      AnchoBanda              : Ancho de la pulsera a utilizar.
//            Valor por defecto 14.1*L.
//      SeparacionBanda         : Separacion de los extremos del soporte de 
//            pulsera. Valor por defecto 34.5*L.
//      GruesoMetal             : Grueso de las laminillas metalicas.
//            Valor por defecto 0.5*L.
//      AnchoPerilla            : Grosor a lo largo del cilindro de calibracion.
//            Valor por defecto 1.7*L.      
//      MaterialPrincipal       : Material principal a aplicar al objeto.
//            Valor por defecto R2X1_MaterialPrincipal. 
//      MaterialCristal         : Material para la cubierta protectora.
//            Valor por defecto R2X1_MaterialCristal.
//      MaterialMetal           : Material para aplicar a zonas metalicas.
//            Valor por defecto R2X1_MaterialMetal.
//      MaterialPerilla         : Material para la perilla de calibracion.
//            Valor por defecto R2X1_MaterialPerilla.
//      MaterialFosforescente   : Material fosforescente sobre parte del
//            horario y minutero. Valor por defecto R2X1_MaterialFosforescente.
//      MaterialSegundero       : Material a aplicar al segundero.
//            Valor por defecto R2X1_MaterialSegundero .
//      
// La reloj con sus valores por defecto se encuentra completamente contenido en:   
//      Punto Minimo    = < -13.6, -17.3,  -6.4 >*L
//      Punto Maximo    = < +15.7, +17.3,  +1.0 >*L 
// El reloj mira con el frente hacia Z- gravedad Y-. El eje de giro de las
// agujas se encuentra en el centro de coordenadas XY. Excepto por el soporte
// de pulsera, la base del reloj descansa sobre el plano XY hacia Z-. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare R2X1_DefaultMaterialPrincipal       
//      Material principal a aplicar al objeto.
// #declare R2X1_DefaultMaterialCristal          
//      Material para la cubierta protectora.
// #declare R2X1_DefaultMaterialMetal           
//      Material para aplicar a zonas metalicas.
// #declare R2X1_DefaultMaterialPerilla         
//      Material para la perilla de calibracion.
// #declare R2X1_DefaultMaterialFosforescente   
//      Material fosforescente sobre parte del horario y minutero. 
// #declare R2X1_DefaultMaterialSegundero       
//      Material a aplicar al segundero.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare R2X1_GIFCaratula               = "R2X1_IM1.gif"  
//      Imagen GIF impresa en la caratula para leer la hora.  
// #declare R2X1_BanderaColorTransparente  = off;
//      "on" indica que algun indice GIF es transparente. "off" no aplica.  
// #declare R2X1_GIFIndiceTransparente     = 0;
//      Valor indice del color transparente GIF si aplica.
// #declare R2X1_NormalCaratula            = normal { bumps }
//      Agrega variacion normal al mapa GIF de la caratula.
// #declare R2X1_FinishCaratula            = finish { }  
//      Agrega finish al mapa GIF de la caratula.
// #declare R2X1_TexturaCaratulaExtra      = texture { pigment { rgbf 1 } }
//      Permite sobreponer una textura adicional en capa sobre
//      la caratula. Util para envejecimiento y efectos similares.
// #declare R2X1_MaterialPrincipal         =
//                  material { R2X1_DefaultMaterialPrincipal }
//      Material principal a aplicar al objeto.
// #declare R2X1_MaterialCristal           =
//                  material { R2X1_DefaultMaterialCristal }
//      Material para la cubierta protectora.
// #declare R2X1_MaterialMetal             =
//                  material { R2X1_DefaultMaterialMetal }
//      Material para aplicar a zonas metalicas.
// #declare R2X1_MaterialPerilla           =
//                  material { R2X1_DefaultMaterialPerilla } 
//      Material para la perilla de calibracion.
// #declare R2X1_MaterialFosforescente     =
//                  material { R2X1_DefaultMaterialFosforescente } 
//      Material fosforescente sobre parte del horario y minutero. 
// #declare R2X1_MaterialSegundero         =
//                  material { R2X1_DefaultMaterialSegundero } 
//      Material a aplicar al segundero.
//        
// Para colocarlo simplemente
// #include "R2X1.inc" 
// object { R2X1_Reloj( 10, 100, 200, on, on ) }
//                                 
// Ejemplo con la macro detallada, mismo objeto default
// #include "R2X1.inc"   
// object                       {
//   R2X1_Reloj2X1( 10, 100, 200, on, on,
//            0.0272, 0.0236, 0.0064, 0.0010, 0.0141, 
//            0.0345, 0.0005, 0.0017,
//            R2X1_MaterialPrincipal, R2X1_MaterialCristal,
//            R2X1_MaterialMetal, R2X1_MaterialPerilla,
//            R2X1_MaterialFosforescente, R2X1_MaterialSegundero )
// }
//        
// Con modificadores
// #include "R2X1.inc"
// #include "textures.inc"
// #declare R2X1_MaterialPrincipal   = material { textures { PinkAlabaster } }
// object        { R2X1_Reloj( 10, 100, 200, on, on ) }
//
#include "colors.inc"
#include "textures.inc"
#include "stones.inc"

#if ( version < 3.2 )
  #ifndef( C2X1_POV3_1 )
    #declare C2X1_POV3_1        = on;
  #end
#else
  #ifndef( C2X1_POV3_1 )
    #declare C2X1_POV3_1        = off;
  #end
#end

#declare R2X1_L                         = 0.001;

#declare R2X1_GIFCaratula               = "R2X1_IM1.gif"  

#declare R2X1_BanderaColorTransparente  = off;

#declare R2X1_GIFIndiceTransparente     = 0;

#declare R2X1_NormalCaratula            = normal { bumps }

#declare R2X1_FinishCaratula            = finish { }  

#declare R2X1_TexturaCaratulaExtra      = texture { pigment { rgbf 1 } }

#declare R2X1_DefaultMaterialPrincipal  =
  material                              {
    texture                             {
      T_Stone10
    }
  }

#ifndef ( R2X1_MaterialPrincipal )
  #declare R2X1_MaterialPrincipal       = R2X1_DefaultMaterialPrincipal
#end  // #ifndef ( R2X1_MaterialPrincipal )

#declare R2X1_DefaultMaterialCristal    =
  material                              {
    #if ( C2X1_POV3_1 )
      texture                           {
        Glass
      }
    #else  // #else ( C2X1_POV3_1 )
      M_Glass
    #end   // #else ( C2X1_POV3_1 )
  }
    
  

#ifndef ( R2X1_MaterialCristal )
  #declare R2X1_MaterialCristal         = R2X1_DefaultMaterialCristal
#end  // #ifndef ( R2X1_MaterialCristal )

#declare R2X1_DefaultMaterialMetal      =
  material                              {
    texture                             {
      Aluminum
    }
  }

#ifndef ( R2X1_MaterialMetal )
  #declare R2X1_MaterialMetal           = R2X1_DefaultMaterialMetal
#end  // #ifndef ( R2X1_MaterialMetal )

#declare R2X1_DefaultMaterialPerilla    =
  material                              {
    texture                             {
      T_Stone10
      normal                            {
        radial
        frequency 30
        sine_wave
        rotate                  90*z
      }
    }
  }

#ifndef ( R2X1_MaterialPerilla )
  #declare R2X1_MaterialPerilla         = R2X1_DefaultMaterialPerilla
#end  // #ifndef ( R2X1_MaterialPerilla )

#declare R2X1_DefaultMaterialFosforescente              =
  material                              {
    texture                             {
      pigment                           {
        White
      }
      finish                            {
        ambient         0.9
        diffuse         0.1
      }
    }
  }

#ifndef ( R2X1_MaterialFosforescente )
  #declare R2X1_MaterialFosforescente   = R2X1_DefaultMaterialFosforescente
#end  // #ifndef ( R2X1_MaterialFosforescente )
   
#declare R2X1_DefaultMaterialSegundero              =
  material                              {
    texture                             {
      pigment                           {
        Red
      }
    }
  }

#ifndef ( R2X1_MaterialSegundero )
  #declare R2X1_MaterialSegundero       = R2X1_DefaultMaterialSegundero
#end  // #ifndef ( R2X1_MaterialSegundero )
   
#macro R2X1_Reloj2X1( AnguloHorario, AnguloMinutero, AnguloSegundero,
                BanderaPulsera, BanderaPerilla, DiametroReloj,
                DiametroCristal, GruesoReloj, ProfundidadCaratula,
                AnchoBanda, SeparacionBanda, GruesoMetal, AnchoPerilla,
                MaterialPrincipal, MaterialCristal, MaterialMetal,
                MaterialPerilla, MaterialFosforescente, MaterialSegundero )
  merge                                 {
    #local DiametroPerilla              =
                3.0/3.4*( GruesoReloj-3*ProfundidadCaratula );
    #local GruesoVidrio                 = 0.1*ProfundidadCaratula;
    #local GruesoAgujas                 = GruesoVidrio/20;
    #local GruesoBanda                  = GruesoReloj-3*ProfundidadCaratula;
    #local SeparacionBanda              =
        sqrt( SeparacionBanda*SeparacionBanda+AnchoBanda*AnchoBanda );
    // Cristal Reloj
    merge                               {
      cylinder                          {
        0, +GruesoVidrio*z, DiametroCristal/2
      }
      difference                        {
        cylinder                        {
          0, +ProfundidadCaratula*z, DiametroCristal/2
        }
        cylinder                        {
          -GruesoVidrio*z, +( ProfundidadCaratula+GruesoVidrio) *z,
          DiametroCristal/2-2*GruesoVidrio
        }
      }
      translate                         -GruesoReloj*z
      material                          {
        MaterialCristal
      }
    }
    // Cristal Reloj
    // Caratula y agujas
    union                                       {
      // Disco Caratula
      cylinder                                {
        0, -GruesoAgujas*z, DiametroCristal/2
        texture                           {
          pigment                         {
            image_map                     {
              gif         R2X1_GIFCaratula   
              #if ( R2X1_BanderaColorTransparente  )
                transmit R2X1_GIFIndiceTransparente, 1.0
              #end  // #if ( R2X1_BanderaColorTransparente )
            }
          }                    
          normal                          {
            R2X1_NormalCaratula
          }                    
          finish                          {
            R2X1_FinishCaratula
          }
          translate               -0.5
          scale           DiametroCristal
        } 
        texture                           {
          R2X1_TexturaCaratulaExtra
        }
      }
      // Horario
      union                                     {
        union                                   {
          box                                     {
            -1, 1
            rotate                45*z
            scale                 <1,0.5,1>
          }
          difference                              {
            box                                   {
              -1, 1
              rotate                45*z
            }
            plane                                 {
              -y, 0
            }
          }
          translate             sqrt(2)*y
          scale                   < 0.015*DiametroCristal, 0.125*DiametroCristal,
                                          GruesoAgujas/4 >
        }
        union                                   {
          box                                     {
            -0.65, 0.65
            rotate                45*z
            scale                 <1,0.5,1>
          }
          difference                              {
            box                                   {
              -0.65, 0.65
              rotate                45*z
            }
            plane                                 {
              -y, 0
            }
          }
          translate             sqrt(2)*y
          scale                  < 0.015*DiametroCristal, 0.125*DiametroCristal,
                                          GruesoAgujas/4 >
          translate                     -GruesoAgujas/4*z
          material                      {
            MaterialFosforescente
          }
        }
        cylinder                                {
          -z, z, 1
          scale         <0.02*DiametroCristal,0.02*DiametroCristal,
                        GruesoAgujas/4>
        }
        translate               -GruesoVidrio*z
        rotate                  -AnguloHorario*z
        material                                {
          MaterialMetal
        }
      }
      // END Horario
      // Minutero
      union                                     {
        union                                   {
          box                                     {
            -1, 1
            rotate                45*z
            scale                 <1,0.5,1>
          }
          difference                              {
            box                                   {
              -1, 1
              rotate                45*z
            }
            plane                                 {
              -y, 0
            }
          }
          translate             sqrt(2)*y
          scale                   < 0.0125*DiametroCristal, 0.170*DiametroCristal,
                                          GruesoAgujas/4 >
        }
        union                                   {
          box                                     {
            -0.65, 0.65
            rotate                45*z
            scale                 <1,0.5,1>
          }
          difference                              {
            box                                   {
              -0.65, 0.65
              rotate                45*z
            }
            plane                                 {
              -y, 0
            }
          }
          translate             sqrt(2)*y
          scale                  < 0.0125*DiametroCristal, 0.170*DiametroCristal,
                                          GruesoAgujas/4 >
          translate                     -GruesoAgujas/4*z
          material                      {
            MaterialFosforescente
          }
        }
        cylinder                                {
          -z, z, 1
          scale         <0.02*DiametroCristal,0.02*DiametroCristal,
                        GruesoAgujas/4>
        }
        translate               -2*GruesoVidrio*z
        rotate                  -AnguloMinutero*z
        material                                {
          MaterialMetal
        }
      }
      // END Minutero
      // Segundero
      union                                     {
        cylinder                                {
          0, +3*GruesoVidrio*z, 0.01*DiametroCristal
        }
        union                                   {
          box                                   {
            <-1,-1.25,-1>, 1
            translate                   y
            scale                  < 0.0045*DiametroCristal, 0.2*DiametroCristal,
                                          GruesoAgujas/4 >
          }
          cylinder                                {
            -z, z, 1
            scale         <0.015*DiametroCristal,0.015*DiametroCristal,
                          GruesoAgujas/4>
          }
          cylinder                                {
            -z, z, 1
            rotate              90*x
            scale         <0.015*DiametroCristal,0.015*DiametroCristal,
                          GruesoAgujas/4>
            translate           -0.25*y*0.2*DiametroCristal
          }
          translate               -3*GruesoVidrio*z
          rotate                  -AnguloSegundero*z
          material                              {
            MaterialSegundero
          }
        }
      }
      // END Segundero
      translate  -( 2*ProfundidadCaratula+GruesoBanda+GruesoVidrio )*z
      // END Disco caratula
    }
    // END Caratula y agujas
    // Base Reloj
    merge                               {
      // Cuerpo Base
      difference                        {
        union                             {
          cylinder                          {
            -ProfundidadCaratula*z, -( GruesoReloj-ProfundidadCaratula )*z,
            DiametroReloj/2-GruesoVidrio
          }
          cylinder                          {
            -2*ProfundidadCaratula*z, -( GruesoReloj-ProfundidadCaratula )*z,
            DiametroReloj/2
          }
          difference                        {
            #local RTorus                   =
                    0.75*( DiametroReloj-DiametroCristal )/2;
            torus                           {
              DiametroCristal/2, RTorus
              rotate                        90*x
              scale                 <1,1,0.8*ProfundidadCaratula/RTorus >
              translate                     -( GruesoReloj-ProfundidadCaratula )*z
            }
            cylinder                          {
              +ProfundidadCaratula*z, -( GruesoReloj+ProfundidadCaratula )*z,
              DiametroCristal/2
            }
          }
        } 
        #if ( BanderaPerilla )
          plane                           {
            -x, -( DiametroReloj/2-0.1*AnchoPerilla )
          }                    
        #end  // #if ( BanderaPerilla )
      }
      // END Cuerpo Base    
      #if ( BanderaPulsera )
      // Puente Base Reloj
      merge                             {
        #local RR                       = SeparacionBanda/2;
        #local RR2                      = RR-3*GruesoMetal;
        #local rr                       = DiametroReloj/2;
        #local hh                       =
                GruesoMetal/2+GruesoReloj-ProfundidadCaratula;
        #local bb                       = hh/
                sqrt( 1-pow( rr/RR, 2 ) );
        #local PuenteMinimo             = AnchoBanda/8;
        #local bb2                      = ( hh-GruesoBanda )/
                sqrt( 1-pow( rr/RR2, 2 ) );
        #local PuenteMinimo             = AnchoBanda/8;
        #local AA                       = DiametroReloj/2
                -AnchoBanda/2-PuenteMinimo;
        #local BB                       =
                SeparacionBanda*SeparacionBanda/(8*AA)-AA/2;
        difference                      {
          union                         {
            difference                  {
              sphere                        {
                0, 1
                scale               < RR, RR, bb >
                translate                   +GruesoMetal/2*z
              }
              plane                         {
                -z, -GruesoMetal/2
              }
            }
            torus                     {
              SeparacionBanda/2-3*GruesoMetal/2, 3*GruesoMetal/2
              rotate                  90*x
              translate                       +GruesoMetal/2*z
            }
          }
          sphere                        {
            0, 1
            scale               < RR2, RR2, bb2 >
            translate                   +GruesoMetal/2*z
          }
          plane                         {
            z, -( GruesoReloj-ProfundidadCaratula )
          }
          box                           {
            < -AnchoBanda/2, -SeparacionBanda, -SeparacionBanda >,
            < +AnchoBanda/2, +SeparacionBanda, +SeparacionBanda >
          }
          cylinder                      {
            -SeparacionBanda*z, SeparacionBanda*z, AA+BB
            translate          +SeparacionBanda/2*y
            translate       ( DiametroReloj/2+BB )*x
          }
          cylinder                      {
            -SeparacionBanda*z, SeparacionBanda*z, AA+BB
            translate          -SeparacionBanda/2*y
            translate       ( DiametroReloj/2+BB )*x
          }
          cylinder                      {
            -SeparacionBanda*z, SeparacionBanda*z, AA+BB
            translate          +SeparacionBanda/2*y
            translate      -( DiametroReloj/2+BB )*x
          }
          cylinder                      {
            -SeparacionBanda*z, SeparacionBanda*z, AA+BB
            translate          -SeparacionBanda/2*y
            translate      -( DiametroReloj/2+BB )*x
          }
        }
        // Guias Metalicas
        #local YGuia                    =
            sqrt( SeparacionBanda*SeparacionBanda-
                        AnchoBanda*AnchoBanda )/2-3*GruesoMetal/2;
        cylinder                        {
          -AnchoBanda/2*x, +AnchoBanda/2*x, GruesoMetal/2
          translate     +YGuia*y+GruesoMetal/2*z
          material                      {
            MaterialMetal
          }
        }
        cylinder                        {
          -AnchoBanda/2*x, +AnchoBanda/2*x, GruesoMetal/2
          translate     -YGuia*y+GruesoMetal/2*z
          material                      {
            MaterialMetal
          }
        }
        // END Guias Metalicas
      }
      // END Puente Base Reloj
      #end  // #if ( BanderaPulsera )
      #if ( BanderaPerilla )
      // Perilla
      merge                             {
        cylinder                        {
          0, +x, 0.5
        }
        cylinder                        {
          -x, 0, 0.4
          material                      {
            MaterialPrincipal
          }
        }
        sphere                          {
          0, 0.5
          scale                 <0.5,1,1>
          material                      {
            MaterialPrincipal
          }
          translate                     x
        }
        material                        {
          MaterialPerilla
        }
        scale             <AnchoPerilla,DiametroPerilla,DiametroPerilla>
        translate                       DiametroReloj/2*x
        translate                       -( 2*ProfundidadCaratula
                                                +GruesoBanda/2 )*z
      }
      // END Perilla
      #end  // #if ( BanderaPerilla )
      material                          {
        MaterialPrincipal
      }
    }
    // END Base Reloj
    // Posterior Metal
    object                              {
      cone                              {
        0, DiametroCristal/2,
        -ProfundidadCaratula*z, DiametroReloj/2-4*GruesoVidrio
      }
      material                          {
        MaterialMetal
      }
    }
    // END Posterior Metal
    material                            {
      MaterialPrincipal
    }
  }
#end  // #macro R2X1_Reloj2X1()

#macro R2X1_Reloj( AnguloHorario, AnguloMinutero, AnguloSegundero,
            BanderaPulsera, BanderaPerilla )
  object                                {
    #local L                            = R2X1_L;
    #local DiametroReloj                =  27.2*L;
    #local DiametroCristal              =  23.6*L;
    #local GruesoReloj                  =   6.4*L;
    #local ProfundidadCaratula          =   1.0*L;
    #local AnchoBanda                   =  14.1*L;
    #local SeparacionBanda              =  34.5*L;
    #local GruesoMetal                  =   0.5*L;
    #local DiametroPerilla              =   3.0*L;
    #local AnchoPerilla                 =   1.7*L;
    R2X1_Reloj2X1( AnguloHorario, AnguloMinutero, AnguloSegundero,
      BanderaPulsera, BanderaPerilla, DiametroReloj,
      DiametroCristal, GruesoReloj, ProfundidadCaratula,
      AnchoBanda, SeparacionBanda, GruesoMetal, AnchoPerilla,
      R2X1_MaterialPrincipal, R2X1_MaterialCristal,
      R2X1_MaterialMetal, R2X1_MaterialPerilla,
      R2X1_MaterialFosforescente, R2X1_MaterialSegundero )
  }
#end  // #macro R2X1_Reloj()
