// This file is licensed under the terms of the CC-LGPL.
//    
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...       
// La imagen corresponde a un juego comercial de mi autoria
// puede encontrarlo en el sitio www.juegosenlazaruscostarricenses.com
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 diciembre de 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// RTSP RompecabezasTodasSusPies
// El archivo dibuja un rompecabezas de tamano e imagen variable, sus
// piezas pueden ser ubicadas a gusto del usuario, por defecto
// se dibujan con todas las piezas en su lugar. 
// Es muy poco flexible. Es compatible con POVRay 3.1.
// 
// El proceso de dibujo requiere llamar a dos macros, una primera de inicializacion
// y luego el dibujo propiamente dicho. Se separo en dos etapas para permitir
// que el usuario realice algunos cambios antes del dibujo final.
// La macro de inicializacion tiene cuatro parametros. 
// #macro RTSP_InicializarRompecabezas
//              ( NombreImagen, VectorContenedor,
//                DensidadPiezas, FactorCorte )   
//      NombreImagen            : Archivo de imagen "GIF" que contiene la imagen
//              a dibujar en el rompecabezas.
//      VectorContenedor        : El rompecabezas estara contenido en un prisma
//              rectangular centrado en el origen con estas dimensiones.
//              Ademas se le agregara una ligera perturbacion aleatoria.
//              Interprete como <AnchoImagen,AltoImagen,GruesoCarton>.
//              La imagen mira en direccion Z-.
//      DensidadPiezas          : Fraccion propia para numero de piezas. Utilice
//              0.0 para dos piezas en la dimension menor y 1.0 para unas
//              treinta piezas en la dimension mayor.
//      FactorCorte             : Fraccion propia para aumentar la separacion
//              entre imagenes sucesivas con un fondo de textura base. 
//              Esto es un efecto "artificial", pero resulta
//              util para percibir la separacion de las piezas.
//                                                            
// Una vez inicializado puede modificar la posicion de las piezas, con los
// modificadores RTSP_GiroPiezas y RTSP_PosicionPiezas. 
// Luego se procede a solicitar una de las dos macros de dibujo. La siguiente macro dibuja
// todas las piezas.   
// #macro RTSP_RompecabezasTodasSusPiezas()  
//
// Esta otra macro dibuja una unica pieza.
// #macro RTSP_RompecabezasUnaPieza( C, D, BanderaUbicar )
//      C                       : Posicion Fila de la pieza de abajo hacia arriba
//              a partir de cero.
//      D                       : Posicion Columna de la pieza de izquierda a derecha
//              a partir de cero.                       
//      BanderaUbicar           : "off" ubica la pieza casi centrada en el origen
//              sin desplazamientos ni efectos aleatorios de posicion.
//              Utilice "on" para dibujar la pieza en posicion, determinada por los
//              arreglos de ubicacion y parametros de perturbacion.
//
// El rompecabezas de juego se encuentra contenido en un box centrado en el origen
// de dimensiones dadas por el parametro VectorContenedor.
// La imagen mira en direccion Z-, y la parte inferior de la imagen apunta hacia Y-.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare RTSP_DefaultTexturaInferior
//      Textura por defecto para la base de carton del rompecabezas.
// #declare RTSP_Filas                
//      Total de filas del rompecabezas luego de la inicialzacion.
// #declare RTSP_Columnas                  
//      Total de columnas del rompecabezas luego de la inicializacion.   
// #declare RTSP_Aleatorio                  = array[2*RTSP_Filas+1][2*RTSP_Columnas+1]  
//      Array bidimensional de los valores aleatorios que se utilizara en el diseno del
//      rompecabezas. Se genera en la inicializacion.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default).
// Para asegurarse que tengan efecto conviene redefinirlos
// antes de la inicializacion, y luego de la inclusion del archivo. 
// RTSP_GiroPiezas y RTSP_PosicionPiezas se generan en el interior de la macro,
// y deberan modificarse posterior a la inicializacion.  
// #declare RTSP_GiroPiezas                 = array[RTSP_Filas][RTSP_Columnas]   
//      La macro de inicializacion genera este arreglo como vectores 3D
//      completamente nulos. No incluye los pequenos efectos de perturbacion
//      aleatorio que se agregan despues. El usuario puede modificarla
//      para agregar el giro que desee, que se aplica antes de trasladar.
// #declare RTSP_PosicionPiezas             = array[RTSP_Filas][RTSP_Columnas]
//      La macro de inicializacion genera este arreglo con las posiciones 3D
//      que ubican al rompecabezas en posicion armada. Puede modificar a combiniencia.
//      Si las modificaciones son muchas, probablemente sea mejor dibujar las
//      piezas individualmente.
// #declare RTSP_PerturbacionAngular        = 2;
//      Angulo de perturbacion (se multiplica por una variable aleatoria),
//      para ubicar las piezas. Puede utilizar 0.0 para ningun efecto. 
//      Es admisible utilizar un Vector 3D.
// #declare RTSP_PerturbacionPosicion       = 0.05;
//      Fraccion propia para intensidad de perturbacion de la posicion de las piezas
//      en su lugar. Esta perturbacion aplica en dos dimensiones.
// #declare RTSP_PerturbacionEsquina        = 0.2;
//      Fraccion propia para intensidad de desplazamiento en las esquinas de forma aleatoria. 
//      Para piezas de forma homogenea deberia anular este y RTSP_FactorDesplazarInterior.
// #declare RTSP_FactorDesplazarInterior    = 0.1;
//      Fraccion propia para intensidad de desplazamiento de los centros de las muescas
//      de agarre de las piezas. 
//      Para piezas de forma homogenea deberia anular este y RTSP_PerturbacionEsquina.
// #declare RTSP_FactorPerturbacionTexturaInferior      = 0.1;
//      Fraccion propia para perturbar la textura inferior de la base
//      con el objetivo que resulte mas simple percibir
//      las piezas en la vista posterior del rompecabezas. Utilice 0.0 para textura
//      homogenea.
// #declare RTSP_FactorCizalla              = 0.05;
//      Fraccion propia pequena para agregar una cizalla a los bordes de imagen,
//      lo que puede aumentar su brillo caracteristico en los bordes.
// #declare RTSP_FactorPapel                = 0.05;
//      Fraccion propia del tamano del papel relativo al grueso Z del rompecabezas.
// #declare RTSP_FactorCorteInferior        = -0.75;
//      Fraccion relativa al Corte Superior. Mide la separacion entre piezas adyacentes.
//      Un valor negativo sirve para eliminar espacios vacios que surgen por la aleatoriedad,
//      pero puede ser positivo o cero.  
// #declare RTSP_DefaultSemilla             = 2100;
//      Valor semilla que se utilizara para generar los efectos aleatorios. Tomar en cuenta
//      que afecta unicamente la inicializacion, luego ya no se volvera a llamar
//      al generador de numeros aleatorios.  
// #declare RTSP_AplicarNormalImagen        = on;
//      "on" aplica RTSP_NormalImagen a la textura de imagen impresa, "off" lo desactiva. 
// #declare RTSP_NormalImagen               = normal { ... } 
//      Normal a aplicar a la textura de imagen si activa.
// #declare RTSP_AplicarFinishImagen        = on;
//      "on" aplica RTSP_FinishImagen a la textura de imagen impresa, "off" lo desactiva.
// #declare RTSP_FinishImagen               = finish { ... }
//      Finish a aplicar a la textura de imagen si activa.
// #declare RTSP_TexturaSobre               = texture { pigment { rgbt 1.0 } }
//      Textura que se aplica en capa sobre la textura de imagen. Por defecto es una
//      capa transparente. Puede ser util para envejecer u otros efectos similares.
// #declare RTSP_TexturaInferior            = texture { RTSP_DefaultTexturaInferior }
//      Textura inferior a aplicar a la base del rompecabezas. En la inicializacion
//      la textura se corrige aplicando el tamano de imagen.   
//        
// Para colocarlo se llama las dos macros en sucesion
// #include "RTSP.inc"    
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )
// object { RTSP_RompecabezasTodasSysPiezas() }
//                                  
// Ejemplo con modificadores
// #include "RTSP.inc"                                 
// #include "textures.inc"
// #declare RTSP_TexturaInferior        = PinkAlabaster
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )   
// #declare RTSP_GiroPiezas[0][0]       = 45;
// object { RTSP_RompecabezasTodasSysPiezas() }
//
// Podemos dibujar una sola pieza sin movimiento adicional        
// #include "RTSP.inc"    
// RTSP_InicializarRompecabezas( "RTSP_IM1.gif", <0.240,0.180,0.001>, 0.15, 0.50 )
// object { RTSP_RompecabezasUnaPieza(0,0,false) }
// 
#include "textures.inc"

#declare RTSP_PerturbacionAngular           = 2;  
#declare RTSP_PerturbacionPosicion          = 0.05;
#declare RTSP_PerturbacionEsquina           = 0.2;
#declare RTSP_FactorCizalla                 = 0.05;
#declare RTSP_FactorPapel                   = 0.05; 
#declare RTSP_FactorDesplazarInterior       = 0.1;  
#declare RTSP_FactorPerturbacionTexturaInferior     = 0.3;  
#declare RTSP_FactorCorteInferior           = -0.75;  
#declare RTSP_DefaultSemilla                = 2100;  
#declare RTSP_AplicarNormalImagen           = on;
#declare RTSP_AplicarFinishImagen           = on; 

#declare RTSP_NormalImagen                  =
  normal                                    {
    wrinkles turbulence 0.2 frequency 10 
  }
             
#declare RTSP_FinishImagen                  =
  finish                                    {
    phong 0.2 phong_size 60 
  }                                               
  
#declare RTSP_TexturaSobre                  =
  texture                                   {
    pigment { rgbt 1.0 }
  }  
             
#declare RTSP_DefaultTexturaInferior    =
  texture                               {
    Cork
    scale         0.01
  }                   
  texture                               {
    pigment { Gray05 transmit 0.10 } 
    normal  { wrinkles }
  }

#ifndef ( RTSP_TexturaInferior )
  #declare RTSP_TexturaInferior         = RTSP_DefaultTexturaInferior
#end  // #ifndef ( RTSP_TexturaInferior )
                                        
#macro RTSP_RompecabezasUnaPieza( C, D, BanderaUbicar )  
    #local DimFila                      = RTSP_DimensionFilas/RTSP_Filas;
    #local DimColumna                   =
                        RTSP_DimensionColumnas/RTSP_Columnas;
    #local Corte                        = RTSP_Corte; 
    #local PIH                      = RTSP_PerturbacionInteriorHorizontal;
    #local PIV                      = RTSP_PerturbacionInteriorVertical;
    #local PEH                      = 2*RTSP_PerturbacionEntradaHorizontal;
    #local PEV                      = 2*RTSP_PerturbacionEntradaVertical;
    #local FF                       = 0.35;
    #local FG                       = 0.40;
    #local SumergirColumna          = 0.30*( DimColumna-Corte );
    #local SumergirFila             = 0.30*( DimFila-Corte );
    #local DesplazarInterior        =
             RTSP_FactorDesplazarInterior*<DimColumna-Corte,DimFila-Corte>;
    #local II                       =
                    ( RTSP_Aleatorio[2*C][2*D]-<0.5,0.5> )*
                                      <DimColumna,DimFila>*
                                      RTSP_PerturbacionEsquina;
    #local SI                       =
                    ( RTSP_Aleatorio[2*C+2][2*D]-<0.5,0.5> )*
                                      <DimColumna,DimFila>*
                                      RTSP_PerturbacionEsquina;
    #local ID                       =
                    ( RTSP_Aleatorio[2*C][2*D+2]-<0.5,0.5> )*
                                      <DimColumna,DimFila>*
                                      RTSP_PerturbacionEsquina;
    #local SD                       =
                    ( RTSP_Aleatorio[2*C+2][2*D+2]-<0.5,0.5> )*
                                      <DimColumna,DimFila>*
                                      RTSP_PerturbacionEsquina;
    #if ( mod( C, 2 ) = mod( D, 2 ) )
      #local CDBit                  = 1.0;
    #else  // #else ( mod( C, 2 ) = 0 )
      #local CDBit                  = -1.0;
    #end   // #else ( mod( C, 2 ) = 0 )
    #if ( C = 0 )
      #local FilI                   = <0,0>;
    #else  // #else ( C = ... )
      #local FilI                   = <0,CDBit*SumergirFila>;
      #local FilI                   = FilI+
            DesplazarInterior*(RTSP_Aleatorio[2*C][2*D+1]-<0.5,0.5>);
    #end   // #else ( C = ... )
    #if ( C = ( RTSP_Filas-1 ) )
      #local FilS                   = <0,0>;
    #else  // #else ( C = ... )
      #local FilS                   = <0,-CDBit*SumergirFila>;
      #local FilS                   = FilS+
            DesplazarInterior*(RTSP_Aleatorio[2*C+2][2*D+1]-<0.5,0.5>);
    #end   // #else ( C = ... )
    #if ( D = 0 )
      #local ColI                   = <0,0>;
    #else  // #else ( D = ... )
      #local ColI                   = <-CDBit*SumergirColumna,0>;
      #local ColI                   = ColI+
            DesplazarInterior*(RTSP_Aleatorio[2*C+1][2*D]-<0.5,0.5>);
    #end   // #else ( D = ... )
    #if ( D = ( RTSP_Columnas-1 ) )
      #local ColD                   = <0,0>;
    #else  // #else ( D = ... )
      #local ColD                   = <CDBit*SumergirColumna,0>;
      #local ColD                   = ColD+
            DesplazarInterior*(RTSP_Aleatorio[2*C+1][2*D+2]-<0.5,0.5>);
    #end   // #else ( D = ... )      
    union                           { 
      #local Cizalla                = RTSP_FactorCizalla;
      #local FactorPapel            = RTSP_FactorPapel;
      prism                           {
        conic_sweep
        bezier_spline
        1-Cizalla, 1,
        //-RTSP_Grueso/2, RTSP_Grueso/2
        64,
        < -( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -PEV*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*II,
        < -( DimColumna-Corte )/2, -(2+PIV*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColI+(1-2*FG)*II,
        < -( DimColumna-Corte )/2,                    0 >+ColI,
        < -( DimColumna-Corte )/2,                    0 >+ColI,
        < -( DimColumna-Corte )/2, +(2+PIV*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColI+(1-2*FG)*SI,
        < -( DimColumna-Corte )/2, +PEV*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SI,
        < -( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SI,
        < -(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -PEH*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FG)*SI,
        < -(2+PIH*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+FilS+(1-2*FG)*SI,
        <                       0, +( DimFila-Corte )/2 >+FilS,
        <                       0, +( DimFila-Corte )/2 >+FilS,
        < +(2+PIH*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+FilS+(1-2*FG)*SD,
        < +PEH*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FG)*SD,
        < +(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SD,
        < +( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +PEV*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*SD,
        < +( DimColumna-Corte )/2, +(2+PIV*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColD+(1-2*FG)*SD,
        < +( DimColumna-Corte )/2,                    0 >+ColD,
        < +( DimColumna-Corte )/2,                    0 >+ColD,
        < +( DimColumna-Corte )/2, -(2+PIV*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColD+(1-2*FG)*ID,
        < +( DimColumna-Corte )/2, -PEV*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+ID,
        < +( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+ID,
        < +(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +PEH*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FG)*ID,
        < +(2+PIH*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+FilI+(1-2*FG)*ID,
        <                       0, -( DimFila-Corte )/2 >+FilI,
        <                       0, -( DimFila-Corte )/2 >+FilI,
        < -(2+PIH*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+FilI+(1-2*FG)*II,
        < -PEH*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FG)*II,
        < -(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+II  
        translate             -y
        scale                 <1,-FactorPapel*RTSP_Grueso/Cizalla,1>
        translate             +(1-2*FactorPapel)*RTSP_Grueso/2*y   
        rotate                        -90*x
        texture                               {
          RTSP_ArregloTexturas[C][D]  
        }  
      }  
      prism                           {                      
        #local CortePivote            = Corte;
        #local Corte                  = RTSP_FactorCorteInferior*Corte;
        bezier_spline
        -RTSP_Grueso/2, +(1-2*FactorPapel)*RTSP_Grueso/2
        64,
        < -( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -0*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*II,
        < -( DimColumna-Corte )/2, -(2+0*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColI+(1-2*FG)*II,
        < -( DimColumna-Corte )/2,                    0 >+ColI,
        < -( DimColumna-Corte )/2,                    0 >+ColI,
        < -( DimColumna-Corte )/2, +(2+0*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColI+(1-2*FG)*SI,
        < -( DimColumna-Corte )/2, +0*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SI,
        < -( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SI,
        < -( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SI,
        < -(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SI,
        < -0*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FG)*SI,
        < -(2+0*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+FilS+(1-2*FG)*SI,
        <                       0, +( DimFila-Corte )/2 >+FilS,
        <                       0, +( DimFila-Corte )/2 >+FilS,
        < +(2+0*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+FilS+(1-2*FG)*SD,
        < +0*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FG)*SD,
        < +(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SD,
        < +(1-2*FF)*( DimColumna-Corte ), +( DimFila-Corte )/2 >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SD,
        < +( DimColumna-Corte )/2, +( DimFila-Corte )/2 >+SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*SD,
        < +( DimColumna-Corte )/2, +0*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*SD,
        < +( DimColumna-Corte )/2, +(2+0*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColD+(1-2*FG)*SD,
        < +( DimColumna-Corte )/2,                    0 >+ColD,
        < +( DimColumna-Corte )/2,                    0 >+ColD,
        < +( DimColumna-Corte )/2, -(2+0*0.2*(-CDBit+1)/2)*(1-2*FG)*( DimFila-Corte ) >+ColD+(1-2*FG)*ID,
        < +( DimColumna-Corte )/2, -0*(-CDBit+1)/2*(1-2*FG)*( DimFila-Corte )/2 >+(1-2*FG)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -(1-2*FF)*( DimFila-Corte ) >+2*(1-2*FF)*ID,
        < +( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+ID,
        < +( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+ID,
        < +(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*ID,
        < +0*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FG)*ID,
        < +(2+0*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+FilI+(1-2*FG)*ID,
        <                       0, -( DimFila-Corte )/2 >+FilI,
        <                       0, -( DimFila-Corte )/2 >+FilI,
        < -(2+0*0.2*(CDBit+1)/2)*(1-2*FG)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+FilI+(1-2*FG)*II,
        < -0*(CDBit+1)/2*(1-2*FG)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FG)*II,
        < -(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*II,
        < -(1-2*FF)*( DimColumna-Corte ), -( DimFila-Corte )/2 >+2*(1-2*FF)*II,
        < -( DimColumna-Corte )/2, -( DimFila-Corte )/2 >+II 
        #local Corte          = CortePivote; 
        rotate                        -90*x
        texture                               {
          RTSP_TexturaInferiorCorregida
          rotate                RTSP_FactorPerturbacionTexturaInferior*
                                400*RTSP_PerturbacionAngular*
                                      ( RTSP_Aleatorio[2*C+1][2*D+1]*<1,1,0>+
                                      RTSP_Aleatorio[2*C+1][2*D+1].u*z/4-<0.5,0.5,0.5/4> )
          translate             -RTSP_FactorPerturbacionTexturaInferior*
                                8*RTSP_PosicionPiezas[C][D]
       }  
      }      
      #if ( BanderaUbicar )
        rotate                RTSP_PerturbacionAngular*
                                    ( RTSP_Aleatorio[2*C+1][2*D+1]*<1,1,0>+
                                    RTSP_Aleatorio[2*C+1][2*D+1].u*z/4-<0.5,0.5,0.5/4> )
        rotate                RTSP_GiroPiezas[C][D]
        translate             RTSP_PerturbacionPosicion*
                              RTSP_Corte*(RTSP_Aleatorio[2*C+1][2*D+1]-<0.5,0.5>)*<1,1,0>
        translate             RTSP_PosicionPiezas[C][D]   
      #end  // #if ( BanderaUbicar )
    }     
#end  // #macro RompecabezasUnaPieza                                        
                                        
#macro RTSP_RompecabezasTodasSusPiezas()
  union                                 {      
    #local C                            = 0;
    #while ( C < RTSP_Filas )
      #local D                          = 0;
      #while ( D < RTSP_Columnas )   
        RTSP_RompecabezasUnaPieza( C, D, on )   
        #local D                        = D+1;
      #end  // #while ( D < RTSP_Columnas )
      #local C                          = C+1;
    #end  // #while ( C < RTSP_Filas )
    texture                             {
      RTSP_TexturaInferiorCorregida
    }
  }
#end  // #macro RTSP_RompecabezasTodasSusPiezas

#macro RTSP_InicializarRompecabezas
              ( NombreImagen, VectorContenedor,
                DensidadPiezas, FactorCorte ) 
  #local Semilla                        = RTSP_DefaultSemilla; 
  #local DimensionColumnas              = VectorContenedor.x;
  #local DimensionFilas                 = VectorContenedor.y;
  #local Grueso                         = VectorContenedor.z;
  #local MinimoFila                     = 
            ( DimensionFilas < DimensionColumnas );
  #local DimMaxima                      =
            min( DimensionFilas, DimensionColumnas );                        
  #local DimMinima                      =
            max( DimensionFilas, DimensionColumnas ); 
  #local PiezasMinimo                   = 2;
  #local PiezasMaximo                   = max( 2, DimMinima/DimMaxima*30 );          
  #local PiezasActual                   =
      PiezasMinimo+DensidadPiezas*( PiezasMaximo-PiezasMinimo );  
  #local DimActual                      =  1.001*DimMinima/PiezasActual;
  #local Filas                          =
            ceil( DimensionFilas/DimActual );
  #local Columnas                       =
            ceil( DimensionColumnas/DimActual );
  #local Corte                          =
            FactorCorte*0.003*DimActual/0.120;   
  #local PertIntEnt                     = Corte*0.120/DimActual/0.003;
  #local PerturbacionInteriorHorizontal = 1.0*PertIntEnt;                                
  #local PerturbacionInteriorVertical   = 1.0*PertIntEnt;                                
  #local PerturbacionEntradaHorizontal  = 1.0*PertIntEnt;                                
  #local PerturbacionEntradaVertical    = 1.0*PertIntEnt;                                
  RTSP_InicializarRompecabezasTodasSusPiezas
              ( NombreImagen, Semilla, Filas, Columnas,
                DimensionFilas, DimensionColumnas, Grueso, Corte,   
                PerturbacionInteriorHorizontal, PerturbacionInteriorVertical,
                PerturbacionEntradaHorizontal , PerturbacionEntradaVertical ,
                RTSP_TexturaInferior )
#end  // #macro RTSP_InicializarRompecabezas                
                
#macro RTSP_InicializarRompecabezasTodasSusPiezas
              ( NombreImagen, Semilla, Filas, Columnas,
                DimensionFilas, DimensionColumnas, Grueso, Corte,   
                PerturbacionInteriorHorizontal, PerturbacionInteriorVertical,
                PerturbacionEntradaHorizontal , PerturbacionEntradaVertical ,
                TexturaInferior )
  #declare RTSP_NombreImagen            = NombreImagen
  #declare RTSP_S                       = seed( Semilla );
  #declare RTSP_Filas                   = Filas;
  #declare RTSP_Columnas                = Columnas;
  #declare RTSP_DimensionFilas          = DimensionFilas;
  #declare RTSP_DimensionColumnas       = DimensionColumnas;
  #declare RTSP_Grueso                  = Grueso;
  #declare RTSP_Corte                   = Corte;
  #declare RTSP_PerturbacionInteriorHorizontal          =
                          PerturbacionInteriorHorizontal;
  #declare RTSP_PerturbacionInteriorVertical            =
                          PerturbacionInteriorVertical;
  #declare RTSP_PerturbacionEntradaHorizontal           =
                          PerturbacionEntradaHorizontal;
  #declare RTSP_PerturbacionEntradaVertical            =
                          PerturbacionEntradaVertical;
  #declare RTSP_TexturaSuperior         = 
    texture                             {
      pigment                           {
        image_map                       {
          gif           NombreImagen
        }
        translate               0.5
        scale                   <DimensionColumnas-Corte,DimensionFilas-Corte,Grueso>
      }       
      #if ( RTSP_AplicarNormalImagen )
        normal { RTSP_NormalImagen scale DimensionColumnas }
      #end  // #if ( RTSP_AplicarNormalImagen )   
      #if ( RTSP_AplicarFinishImagen )        
        finish { RTSP_FinishImagen }
      #end  // #if ( RTSP_AplicarFinishImagen )
    }  
    texture       { RTSP_TexturaSobre }
  #declare RTSP_TexturaInferiorCorregida        =
    texture                             {
      TexturaInferior
      scale                     <DimensionColumnas,DimensionFilas,Grueso>
    }
  #local MaxC                           = 2*Filas+1;
  #local MaxD                           = 2*Columnas+1;
  #declare RTSP_GiroPiezas              = array[Filas][Columnas]
  #declare RTSP_PosicionPiezas          = array[Filas][Columnas]
  #declare RTSP_ArregloTexturas         = array[Filas][Columnas]
  #declare RTSP_Aleatorio               = array[MaxC][MaxD]
  #local C                              = 0;
  #while ( C < MaxC )
    #local D                            = 0;
    #while ( D < MaxD )
      #if ( ( C = 0 ) | ( D = 0 ) | ( C = ( MaxC-1 ) ) | ( D = ( MaxD-1 ) ) )
        #declare RTSP_Aleatorio[C][D]   = <0.5,0.5>;
      #else
        #declare RTSP_Aleatorio[C][D]   = <rand(RTSP_S),rand(RTSP_S)>;
      #end
      #local D                          = D+1;
    #end  // #while ( D < MaxD )
    #local C                            = C+1;
  #end  // #while ( C < MaxC )
  #local C                              = 0;
  #while ( C < Filas )
    #local D                            = 0;
    #while ( D < Columnas )
      #declare RTSP_GiroPiezas[C][D]            = <0,0,0>;
      #declare RTSP_PosicionPiezas[C][D]        =
                        < ( D+0.5-Columnas/2 )*DimensionColumnas/Columnas,
                          ( C+0.5-Filas/2 )*DimensionFilas/Filas, 0 >;
      #declare RTSP_ArregloTexturas[C][D]       =
                texture                 {  
                  RTSP_TexturaSuperior
                  translate             -RTSP_PosicionPiezas[C][D]  
                }
      #local D                          = D+1;
    #end  // #while ( D < Columnas )
    #local C                            = C+1;
  #end  // #while ( C < Filas )
#end  // #macro RTSP_InicializarRompecabezas

